﻿using FreeSql;
using FreeSql.DataAnnotations;
using System.Collections.Generic;

namespace ojbk.Entities
{
    /// <summary>
    /// 岗位
    /// </summary>
    public partial class Position : BaseEntity<Position, int>
    {
        /// <summary>
        /// 部门id
        /// </summary>
        public int DepartmentId { get; set; }
        /// <summary>
        /// 部门
        /// </summary>
        [Navigate(nameof(DepartmentId))]
        public Department Department { get; set; }

        /// <summary>
        /// 岗位称呼
        /// </summary>
        public string Title { get; set; }

        /// <summary>
        /// 职责内容
        /// </summary>
        public string DutyContent { get; set; }
        /// <summary>
        /// 工作内容
        /// </summary>
        public string JobContent { get; set; }
    }

    #region ManyToMany Employee
    partial class Position
    {
        [Navigate(ManyToMany = typeof(Position.PositionEmployee))]
        public List<Employee> Employees { get; set; }

        public class PositionEmployee : BaseEntity<PositionEmployee>
        {
            public int PositionId { get; set; }
            public Position Position { get; set; }

            public int EmployeeId { get; set; }
            public Employee Employee { get; set; }
        }
    }
    partial class Employee
    {
        [Navigate(ManyToMany = typeof(Position.PositionEmployee))]
        public List<Position> Positions { get; set; }

        [Navigate(nameof(Position.PositionEmployee.EmployeeId))]
        public List<Position.PositionEmployee> PositionEmployees { get; set; }
    }
    #endregion


    #region ManyToMany AuthRole
    partial class Role
    {
        [Navigate(ManyToMany = typeof(Role.RolePosition))]
        public List<Position> Positions { get; set; }

        public class RolePosition : BaseEntity<RolePosition>
        {
            public int RoleId { get; set; }
            public Role Role { get; set; }

            public int PositionId { get; set; }
            public Position Position { get; set; }
        }
    }
    partial class Position
    {
        [Navigate(ManyToMany = typeof(Role.RolePosition))]
        public List<Role> Roles { get; set; }
    }
    #endregion
}
