﻿using FreeSql;
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ojbk.Entities
{
    partial class User
    {
        /// <summary>
        /// 登陆用户，查询岗位表
        /// </summary>
        [JsonIgnore]
        public ISelect<Position> SelectPosition => this.IsAdmin ?
            Position.Select :
            Position.Select.Where(a => a.Roles.Any(r => r.RoleUsers.Any(ur => ur.UserId == this.Id)));

        /// <summary>
        /// 登陆用户，查询员工表
        /// </summary>
        [JsonIgnore]
        public ISelect<Employee> SelectEmployee => this.IsAdmin ?
            Employee.Select :
            Employee.Select.Where(a => a.Positions.Any(p => p.Roles.Any(r => r.RoleUsers.Any(ur => ur.UserId == this.Id))));

    }
}
