﻿using FreeSql;
using FreeSql.DataAnnotations;
using System.Collections.Generic;

namespace ojbk.Entities
{
    /// <summary>
    /// 角色
    /// </summary>
    public partial class Role : BaseEntity<Role, int>
    {
        /// <summary>
        /// 名称
        /// </summary>
        public string Name { get; set; }

        /// <summary>
        /// 备注
        /// </summary>
        public string Remark { get; set; }
    }

    #region ManyToMany User
    partial class Role
    {
        [Navigate(nameof(Role.AuthRoleUser.RoleId))]
        public List<Role.AuthRoleUser> RoleUsers { get; set; }

        [Navigate(ManyToMany = typeof(Role.AuthRoleUser))]
        public List<User> Users { get; set; }

        public class AuthRoleUser : BaseEntity<AuthRoleUser>
        {
            public int RoleId { get; set; }
            public Role Role { get; set; }

            public int UserId { get; set; }
            public User User { get; set; }
        }
    }
    partial class User
    {
        [Navigate(ManyToMany = typeof(Role.AuthRoleUser))]
        public List<Role> Roles { get; set; }
    }
    #endregion
}
