using FreeSql;
using IdleScheduler;
using ojbk.Entities;

var fsql = new FreeSql.FreeSqlBuilder()
    .UseConnectionString(FreeSql.DataType.Sqlite, @"Data Source=test.db;Pooling=true;Max Pool Size=10")
    .UseAutoSyncStructure(true)
    .UseNoneCommandParameter(true)
    .UseMonitorCommand(cmd => Console.WriteLine(cmd.CommandText + "\r\n"))
    .Build();
var scheduler = new Scheduler(new IdleScheduler.TaskHandlers.FreeSqlHandler(fsql));

var builder = WebApplication.CreateBuilder(args);

builder.Services.AddControllersWithViews();
builder.Services.AddSingleton(fsql);
builder.Services.AddEndpointsApiExplorer();
builder.Services.AddSwaggerGen();

var app = builder.Build();

if (app.Environment.IsDevelopment())
{
    app.UseSwagger();
    app.UseSwaggerUI();
}

app.UseAuthorization();
app.MapControllers();

app.UseDefaultFiles();
app.UseStaticFiles();

//Ŀ¼ʣ磺/testadmin/
app.UseFreeAdminLtePreview("/",
    typeof(Config),
    typeof(Role),
    typeof(Menu),
    typeof(User),

    typeof(Department),
    typeof(Employee),
    typeof(Position),

    typeof(AppLog),
    typeof(LoginLog),
    typeof(OprationLog),

    typeof(IdleScheduler.TaskInfo),
    typeof(IdleScheduler.TaskLog)
);

//ѭִ10Σÿμ10
scheduler.AddTask(topic: "test001", body: "data1", round: 10, seconds: 10);
//scheduler ÿ򣬻Զ

app.Run();
scheduler.Dispose();
fsql.Dispose();
